From ece01ea7c48861a342ab22f58d16652f44f960d4 Mon Sep 17 00:00:00 2001
From: Jeremy Cline <jeremy@jcline.org>
Date: Sep 29 2016 13:42:27 +0000
Subject: [PATCH 644/1001] Add a Vagrantfile and Ansible role


This is a first pass at a Vagrantfile and Ansible role to automate the
setup of a development environment. This also adds a basic dev guide
document which, at the moment, only includes Vagrant instructions. I
plan to organize the documentation and update the README in a separate
commit.

closes #254

Signed-off-by: Jeremy Cline <jeremy@jcline.org>

---

diff --git a/.gitignore b/.gitignore
index 096613a..357e7b0 100644
--- a/.gitignore
+++ b/.gitignore
@@ -9,3 +9,10 @@ scratch/
 npm-debug.log
 client_secrets.json
 hubs.js
+
+# Vagrant and Ansible files
+Vagrantfile
+.dnf-cache
+*.retry
+*.pem
+config
diff --git a/Vagrantfile.example b/Vagrantfile.example
new file mode 100644
index 0000000..7fff78d
--- /dev/null
+++ b/Vagrantfile.example
@@ -0,0 +1,63 @@
+# -*- mode: ruby -*-
+# vi: set ft=ruby :
+
+VAGRANTFILE_API_VERSION = "2"
+
+Vagrant.configure(VAGRANTFILE_API_VERSION) do |config|
+ config.vm.box = "fedora/24-cloud-base"
+
+ # Forward traffic on the host to the development server on the guest
+ config.vm.network "forwarded_port", guest: 5000, host: 5000
+
+ # Comment out if you don't want Vagrant to add and remove entries from /etc/hosts for each VM.
+ # requires the vagrant-hostmanager plugin to be installed
+ if Vagrant.has_plugin?("vagrant-hostmanager")
+     config.hostmanager.enabled = true
+     config.hostmanager.manage_host = true
+ end
+
+ # Vagrant can share the source directory using rsync, NFS, or SSHFS (with the vagrant-sshfs
+ # plugin). By default it rsyncs the current working directory to /vagrant. We disable this
+ # in favor of SSHFS.
+ #
+ # If you would prefer to use NFS to share the directory uncomment this and configure NFS
+ #config.vm.synced_folder ".", "/vagrant", type: "nfs", nfs_version: 4, nfs_udp: false
+ config.vm.synced_folder ".", "/vagrant", disabled: true
+ config.vm.synced_folder ".", "/home/vagrant/devel", type: "sshfs", sshfs_opts_append: "-o nonempty"
+
+ # To cache update packages (which is helpful if frequently doing `vagrant destroy && vagrant up`)
+ # you can create a local directory and share it to the guest's DNF cache. The directory needs to
+ # exist, so create it before you uncomment the line below.
+ #config.vm.synced_folder ".dnf-cache", "/var/cache/dnf", type: "sshfs", sshfs_opts_append: "-o nonempty"
+
+ # Comment this line if you would like to disable the automatic update during provisioning
+ config.vm.provision "shell", inline: "sudo dnf upgrade -y"
+
+ # Install packages required for Ansible and configure everything with ansible
+ config.vm.provision "shell", inline: "sudo dnf -y install python2-dnf libselinux-python"
+ config.vm.provision "ansible" do |ansible|
+     ansible.playbook = "ansible/vagrant-playbook.yml"
+ end
+
+
+ # Create the "pagure" box
+ config.vm.define "hubs" do |hubs|
+    hubs.vm.host_name = "hubs-dev.example.com"
+
+    hubs.vm.provider :libvirt do |domain|
+        # Season to taste
+        domain.cpus = 4
+        domain.graphics_type = "spice"
+        domain.memory = 2048
+        domain.video_type = "qxl"
+
+        # Uncomment the following line if you would like to enable libvirt's unsafe cache
+        # mode. It is called unsafe for a reason, as it causes the virtual host to ignore all
+        # fsync() calls from the guest. Only do this if you are comfortable with the possibility of
+        # your development guest becoming corrupted (in which case you should only need to do a
+        # vagrant destroy and vagrant up to get a new one).
+        #
+        #domain.volume_cache = "unsafe"
+    end
+ end
+end
diff --git a/ansible/roles/hubs-dev/files/bashrc b/ansible/roles/hubs-dev/files/bashrc
new file mode 100644
index 0000000..615b5df
--- /dev/null
+++ b/ansible/roles/hubs-dev/files/bashrc
@@ -0,0 +1,39 @@
+# .bashrc
+
+# Source global definitions
+if [ -f /etc/bashrc ]; then
+    . /etc/bashrc
+fi
+
+# Uncomment the following line if you don't like systemctl's auto-paging feature:
+# export SYSTEMD_PAGER=
+
+# User specific aliases and functions
+# If adding new functions to this file, note that you can add help text to the function
+# by defining a variable with name _<function>_help containing the help text
+
+# Set up virtualenvwrapper
+export WORKON_HOME=$HOME/.virtualenvs
+export PIP_VIRTUALENV_BASE=$WORKON_HOME
+export VIRTUALENV_USE_DISTRIBUTE=true
+export PIP_RESPECT_VIRTUALENV=true
+source /usr/bin/virtualenvwrapper.sh
+
+export HUBS_CONFIG=~/devel/config
+
+
+hup() {
+    workon hubs
+    pushd ~/devel/
+    python ./runserver.py --host 0.0.0.0
+}
+
+hreset() {
+    workon hubs
+    rm /var/tmp/hubs.db
+    rm /var/tmp/fedora-hubs-cache.db
+    pushd ~/devel/
+    python populate.py
+    popd
+    deactivate
+}
diff --git a/ansible/roles/hubs-dev/files/datanommer.py b/ansible/roles/hubs-dev/files/datanommer.py
new file mode 100644
index 0000000..30de6fb
--- /dev/null
+++ b/ansible/roles/hubs-dev/files/datanommer.py
@@ -0,0 +1,4 @@
+config = {
+    'datanommer.enabled': True,
+    'datanommer.sqlalchemy.url': 'postgres://datanommer@localhost/datanommer',
+}
diff --git a/ansible/roles/hubs-dev/files/hubs_config b/ansible/roles/hubs-dev/files/hubs_config
new file mode 100644
index 0000000..83417df
--- /dev/null
+++ b/ansible/roles/hubs-dev/files/hubs_config
@@ -0,0 +1,4 @@
+# Enter any hubs configuratio here
+
+# Allow the cookie to be sent of http since we work on localhost
+OIDC_ID_TOKEN_COOKIE_SECURE = False
diff --git a/ansible/roles/hubs-dev/files/motd b/ansible/roles/hubs-dev/files/motd
new file mode 100644
index 0000000..f3d92ab
--- /dev/null
+++ b/ansible/roles/hubs-dev/files/motd
@@ -0,0 +1,18 @@
+
+Welcome to the Fedora Hubs development environment!
+
+Here are some tips:
+
+* The code for Fedora Hubs is located at ~/devel/
+
+* You can type `workon hubs` to enter a configured Python virtualenv
+
+* Run `hup` to start gunicorn
+
+* Run `hreset` to delete the database and repopulate it
+
+Once you run `hup` you can navigate to http://localhost:5000/
+in your browser.
+
+Happy hacking!
+
diff --git a/ansible/roles/hubs-dev/files/pg_hba.conf b/ansible/roles/hubs-dev/files/pg_hba.conf
new file mode 100644
index 0000000..fb47623
--- /dev/null
+++ b/ansible/roles/hubs-dev/files/pg_hba.conf
@@ -0,0 +1,14 @@
+# PostgreSQL Client Authentication Configuration File
+# ===================================================
+#
+# Refer to the "Client Authentication" section in the PostgreSQL
+# documentation for a complete description of this file.
+
+# TYPE  DATABASE        USER            ADDRESS                 METHOD
+
+# "local" is for Unix domain socket connections only
+local   all             all                                     trust
+# IPv4 local connections:
+host    all             all             127.0.0.1/32            trust
+# IPv6 local connections:
+host    all             all             ::1/128                 trust
